

   MEMBER('ClarionTest.clw')                               ! This is a MEMBER module


   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('CLARIONTEST001.INC'),ONCE        !Local module procedure declarations
                     END


!!! <summary>
!!! Generated from procedure template - Window
!!! </summary>
RunTests PROCEDURE 

firstdisplay	byte(true)
TestRunner	ClarionTest_TestRunner
ProcQ           queue(ClarionTest_ProceduresQueue)
				end
x               LONG
TestResult	&ClarionTest_TestResult
                itemize(1),pre(Style)
Default             equate
Passed              equate
Failed              equate
                end
runall              byte(true)
DllNameAndPath	cstring(255)
dbg             system_diagnostics_debugger
TestDll              STRING(255)                           !
LB_Passed            BYTE                                  !
LB_UnitTest          STRING(100)                           !
LB_Result            STRING(200)                           !
  ! LIST,AT(13,31,349,219),USE(?LIST),HVSCROLL,FORMAT('162L(2)MY~Test Name~@s100@800L(2)Y~Result~@s200@'),FROM(ProcQ),MARK(procq.mark)
                
Window               WINDOW('Clarion test harness'),AT(,,523,275),FONT('Microsoft Sans Serif',8,,FONT:regular), |
  RESIZE,GRAY,SYSTEM
                       PROMPT('Test Dll:'),AT(12,15),USE(?TestDll:Prompt)
                       ENTRY(@s255),AT(43,14,459,10),USE(TestDll)
                       BUTTON('...'),AT(506,14,10,10),USE(?LookupFile)
                       LIST,AT(13,31,502,219),USE(?LIST),HVSCROLL,FORMAT('259L(2)MY~Test Name~@s100@800L(2)Y~R' & |
  'esult~@s200@'),FROM(ProcQ),MARK(procq.mark)
                       BUTTON('Re&load'),AT(13,254,84),USE(?Reload)
                       BUTTON('&Reload and Run All'),AT(101,254,84,14),USE(?ReloadAndRun)
                       BUTTON('Run &All'),AT(189,254,84),USE(?RunAll)
                       BUTTON('Run &Selected'),AT(277,254,84),USE(?RunSelected)
                       BUTTON('&Close'),AT(462,254,54),USE(?Close),FONT('Microsoft Sans Serif',,,FONT:regular)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeFieldEvent         PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
FileLookup1          SelectFileClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()                        ! Opens the window and starts an Accept Loop

Refresh             routine
    setcursor(cursor:wait)
	firstDisplay = false
	TestRunner.Init(testdll)
    TestRunner.GetTestProcedures(ProcQ)
	loop x = 1 to records(Procq)
		get(Procq,x)
		Procq.TestNameStyle = Style:Default
		Procq.PassedStyle = Style:Default
		ProcQ.TestResultStyle = Style:Default
		procQ.Mark = false		 
		put(ProcQ)
	END
    if ~records(procq)
        procq.TestName = 'No tests loaded'
        add(procq)
    END
	TestRunner.Kill()
    setcursor()
    display()
    
RunTests            ROUTINE
    setcursor(cursor:wait)
	dbg.write('RunTests routine is initializing the dll') 
	TestRunner.Init(testdll)
	loop x = 1 to records(ProcQ)
		get(ProcQ,x)
            !dbg.Message('Got record ' & x & ', test ' & procq.TestName)
		if ~runall and procq.mark = FALSE
                !dbg.Message('Skipping this item')
			CYCLE
		END
		dbg.write('Running test ' & procq.TestName)
		TestResult &= TestRunner.RunTest(x)
		ProcQ.TestResultStyle = Style:Failed
		if TestResult &= null
			procq.passed = false
			procq.TestResult = 'Failed: TestResult object was null'
		ELSE
			procq.TestName = TestResult.ProcedureName
			if TestResult.Passed
				procq.TestResult = 'Passed'
				ProcQ.TestResultStyle = Style:Passed
			ELSE
				procq.TestResult = 'Failed: ' & TestResult.Message
			END
		END
		put(procq)
	end
	TestRunner.Kill()
    display()
    setcursor()
    
!---------------------------------------------------------------------------
DefineListboxStyle ROUTINE
!|
!| This routine create all the styles to be shared in this window
!| It`s called after the window open
!|
  !------------------------------------
  !Style for ?LIST
  !------------------------------------
!---------------------------------------------------------------------------

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  	!dbg.init('RunTests')
  	!dbg.debugactive = true
  	
  
  	!dbg.Message('command(): ' & TestDll)
  GlobalErrors.SetProcedureName('RunTests')
    if TestDll = ''
    end
  SELF.Request = GlobalRequest                             ! Store the incoming request
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?TestDll:Prompt
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors                              ! Set this windows ErrorManager to the global ErrorManager
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)                                     ! Clear GlobalRequest after storing locally
  CLEAR(GlobalResponse)
  IF SELF.Request = SelectRecord
     SELF.AddItem(?Close,RequestCancelled)                 ! Add the close control to the window manger
  ELSE
     SELF.AddItem(?Close,RequestCompleted)                 ! Add the close control to the window manger
  END
  SELF.Open(Window)                                        ! Open window
  	?list{PROPSTYLE:TextColor, Style:Default}     = -1
  	?list{PROPSTYLE:BackColor, Style:Default}     = -1
  	?list{PROPSTYLE:TextSelected, Style:Default}  = -1
  	?list{PROPSTYLE:BackSelected, Style:Default}  = -1
  
  	?list{PROPSTYLE:TextColor, Style:Passed}     = color:green
  	?list{PROPSTYLE:BackColor, Style:Passed}     = color:white
  	?list{PROPSTYLE:TextSelected, Style:Passed}  = -1
  	?list{PROPSTYLE:BackSelected, Style:Passed}  = -1
  
  	?list{PROPSTYLE:TextColor, Style:Failed}     = color:red
  	?list{PROPSTYLE:BackColor, Style:Failed}     = color:white
  	?list{PROPSTYLE:TextSelected, Style:Failed}  = -1
  	?list{PROPSTYLE:BackSelected, Style:Failed}  = -1
        
  	TestDll = clip(left(COMMAND(1)))
  	if instring('\',testdll,1,1) = 0
  		TestDll = longpath() & '\' & TestDll 
  		display(?testdll)
  	end
  
  	do refresh
  	if command('/run')
  		post(event:accepted,?runall)
  	end
  Do DefineListboxStyle
  Window{PROP:MinWidth} = 523                              ! Restrict the minimum window width
  Window{PROP:MinHeight} = 100                             ! Restrict the minimum window height
  Resizer.Init(AppStrategy:Spread)                         ! Controls will spread out as the window gets bigger
  SELF.AddItem(Resizer)                                    ! Add resizer to window manager
  INIMgr.Fetch('RunTests',Window)                          ! Restore window settings from non-volatile store
  Resizer.Resize                                           ! Reset required after window size altered by INI manager
  FileLookup1.Init
  FileLookup1.ClearOnCancel = True
  FileLookup1.Flags=BOR(FileLookup1.Flags,FILE:LongName)   ! Allow long filenames
  FileLookup1.SetMask('Test DLL','*.dll')                  ! Set the file mask
  FileLookup1.WindowTitle='Load DLL containing test procedures'
    !do UpdateList
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('RunTests',Window)                       ! Save window data to non-volatile store
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receive all EVENT:Accepted's
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?TestDll
          do Refresh
    OF ?Reload
                  do Refresh      
    OF ?RunAll
              runall = TRUE
              do RunTests
    OF ?RunSelected
              runall = FALSE
              do RunTests
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?LookupFile
      ThisWindow.Update
      TestDll = FileLookup1.Ask(0)
      DISPLAY
    OF ?ReloadAndRun
      ThisWindow.Update
      Do Refresh
      runall = TRUE
      do RunTests
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeFieldEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP                                                     ! This method receives all field specific events
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  CASE FIELD()
  OF ?LookupFile
                  do Refresh          
  END
  ReturnValue = PARENT.TakeFieldEvent()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults()                                 ! Calculate default control parent-child relationships based upon their positions on the window
  SELF.SetStrategy(?Reload, Resize:FixLeft, Resize:LockSize) ! Override strategy for ?Reload
  SELF.SetStrategy(?ReloadAndRun, Resize:FixLeft, Resize:LockSize) ! Override strategy for ?ReloadAndRun
  SELF.SetStrategy(?RunAll, Resize:FixLeft, Resize:LockSize) ! Override strategy for ?RunAll
  SELF.SetStrategy(?RunSelected, Resize:FixLeft, Resize:LockSize) ! Override strategy for ?RunSelected
  SELF.SetStrategy(?Close, Resize:FixRight, Resize:LockSize) ! Override strategy for ?Close
  SELF.SetStrategy(?LIST, Resize:FixLeft+Resize:FixTop, Resize:Resize) ! Override strategy for ?LIST
  SELF.SetStrategy(?TestDll:Prompt, Resize:FixLeft+Resize:FixTop, Resize:LockSize) ! Override strategy for ?TestDll:Prompt
  SELF.SetStrategy(?TestDll, Resize:FixLeft+Resize:FixTop, Resize:LockSize) ! Override strategy for ?TestDll
  SELF.SetStrategy(?LookupFile, Resize:FixLeft+Resize:FixTop, Resize:LockSize) ! Override strategy for ?LookupFile

