					MEMBER

	include('windows.inc'),once

					MAP
						MODULE('Windows.lib')
							FileTimeToSystemTime(*FileTimeGroup,*SystemTimeGroup),BOOL,PASCAL,RAW
							FileTimeToLocalFileTime(*FileTimeGroup,*FileTimeGroup),BOOL,PASCAL,RAW
							FileTimeToDosDateTime(*FileTimeGroup,*WORD,*WORD),BOOL,PASCAL,RAW
							SystemTimeToFileTime(*SystemTimeGroup,*FileTimeGroup),BOOL,PASCAL,RAW
							SetFileTime(HANDLE,*FileTimeGroup,*FileTimeGroup,*FileTimeGroup),BOOL,PASCAL,RAW
							CreateFileA( *CSTRING lpFileName, 	|
								ulong dwDesiredAccess, 	|
								ulong dwShareMode, 		|
								ulong lpSecurityAttributes, 	|
								ulong dwCreationDisposition, | 
								ulong dwFlagsAndAttributes,	| 
								ulong hTemplateFile),long, raw, pascal
						END
					END




	INCLUDE('System_IO_File.inc'),ONCE
	include('System_String.inc'),once
	include('System_Diagnostics_Debugger.inc'),once

dbg                 System_Diagnostics_Debugger

System_IO_File.SetFileTime  procedure(long newdate, long newtime)		
stime                           group(SystemTimeGroup)
								end
ftime                           group(FileTimeGroup)
								end
hnd                             HANDLE


	CODE
	dbg.SetPrefix('System_IO_File.SetFileTime')
	clear(stime)
	stime.wyear = year(newdate)
	stime.wMonth = month(newdate)
	!stime.wDayOfWeek = 
	stime.wDay = day(newdate)
	SystemTimetoFiletime(stime,ftime)
	dbg.write('ftime.dwLowDateTime ' & ftime.dwLowDateTime)
	dbg.write('ftime.dwHighDateTime ' & ftime.dwHighDateTime)
	hnd = CreateFileA(self.filename,Generic_Read,0,0,OpenExisting,0,0)
	dbg.Write('handle: ' & hnd)
	SetFileTime(hnd,ftime,ftime,ftime)
	
	


System_IO_File.Init procedure(string filename)
	CODE
	self.FileName = filename
	
System_IO_File.GetSafeFilename      procedure!,string
x                                       long
PrevCharIsSpace                         byte(false)
str                                     System_String
	code
	str.Assign('')
	loop x = 1 to len(clip(self.filename))
		case self.FileName[x]
		of '*'
			PrevCharIsSpace = false
			str.append('&')
		of '?'
			PrevCharIsSpace = false
			str.append('~')
		of '<<'
			PrevCharIsSpace = false
			str.append('{{')
		of '>'
			PrevCharIsSpace = false
			str.append('}')
		of ':'
			PrevCharIsSpace = false
			str.append('!')
		of ' '
			if self.RemoveDuplicateSpaces
				if ~PrevCharIsSpace
					str.Append(' ')
				end
			else
				str.append(' ')
			end
			PrevCharIsSpace = true
		of '/'
		orof '\'
		orof '|'
		orof '"'
			PrevCharIsSpace = false
			str.append('_')
		ELSE
			PrevCharIsSpace = false
			str.append(self.FileName[x])
		end
	end
	return str.Get()
			
	
	
	
	
					


  